package cpcns.dingZhi.zhuanYeWenJian.service.impl;

package .tmp;

import cpcns.baoguanqixiancelue.service.IGQuanZongWeiHuService;
import cpcns.base.common.User;
import cpcns.base.configuration.AppConfiguration;
import cpcns.dangAnBase.base.service.impl.DangAnBaseServiceImpl;
import cpcns.dingZhi.zhuanYeWenJian.dao.IZhuanYeWenJianDao;
import cpcns.dingZhi.zhuanYeWenJian.model.zhuanYeWenJian;
import cpcns.dingZhi.zhuanYeWenJian.service.IZhuanYeWenJianService;
import cpcns.utils.CommStatic;
import cpcns.utils.PagerVO;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service("zhuanYeWenJianService")
public class ZhuanYeWenJianServiceImpl extends DangAnBaseServiceImpl<zhuanYeWenJian> implements IZhuanYeWenJianService {
  @Autowired
  private IZhuanYeWenJianDao zhuanYeWenJianDao;
  
  @Autowired
  private IGQuanZongWeiHuService quanZongWeiHuService;
  
  public PagerVO query_SQL(User user, Integer start, Integer rows, String table, Map<String, Object> map, String orderbysql) throws Exception {
    Map<String, Object> tp = new HashMap<>();
    StringBuffer sql = (new StringBuffer(" select wj.hangBiaoShi,wj.biaoTi,wj.quanZongHao,wj.guiDangNianDu,wj.muLuHao,wj.cunFangWeiZhi,wj.dangHao,wj.fenLeiMingCheng,wj.fenLeiHao,wj.zeRenZhe,wj.xingBie,wj.siWangShiJian,wj.anJuanHao,wj.miJi from ")).append(table).append(" wj where 1=1 and wj.zhuangTai not in(:zhuangTai)");
    Object importExcelTool = map.get("importTool");
    if (StringUtils.isNotBlank((String)importExcelTool))
      sql = (new StringBuffer(" select wj.hangBiaoShi,wj.biaoTi,wj.quanZongHao,wj.guiDangNianDu,wj.muLuHao,wj.cunFangWeiZhi,wj.dangHao,wj.fenLeiMingCheng,wj.fenLeiHao,wj.zeRenZhe,wj.xingBie,wj.siWangShiJian,wj.anJuanHao from ")).append(table).append(" wj where 1=1 and wj.zhuangTai in(:zhuangTai)"); 
    boolean fl = getInitVal("chaXunQuanXianKongZhi", "chaXunQuanXianKongZhi");
    if (fl) {
      Map<String, String> tjmap = new HashMap<>();
      String quanZongHao = (String)map.get("quanZongHao");
      String checkbox = (map.get("checkbox") == null) ? "false" : (String)map.get("checkbox");
      String all_qz = this.quanZongWeiHuService.getAllQzuanZhong(user.getQuanZongHao());
      tjmap.put("guanLianQuanZong", all_qz);
      tjmap.put("checkbox", checkbox);
      tjmap.put("quanZongHao", quanZongHao);
      tjmap.put("table", table);
      sql.append(CommStatic.IsQuanXian(user, AppConfiguration.getConfigValue("CPCNS_XITONGLEIXING"), tjmap));
    } 
    pinjieSql(sql, tp, map);
    return this.zhuanYeWenJianDao.querySQL(start, rows, sql.toString(), tp, orderbysql);
  }
  
  public List<Map<String, Object>> getDate(String table, Map<String, Object> map, User user) {
    Map<String, Object> tp = new HashMap<>();
    StringBuffer sql = null;
    if (StringUtils.isNotBlank((String)map.get("menLei")) && ("JJAJWS".equals(map.get("menLei")) || "YPWS".equals(map.get("menLei")) || "SWGBWS".equals(map.get("menLei")))) {
      sql = (new StringBuffer(" select wj.beiZhu,wj.jiGuan,wj.yeShu,wj.hangBiaoShi,wj.biaoTi,wj.quanZongHao,wj.guiDangNianDu,wj.muLuHao,wj.cunFangWeiZhi,wj.dangHao,wj.fenLeiMingCheng,wj.fenLeiHao,wj.zeRenZhe,TO_CHAR(wj.siWangShiJian, 'yyyy=mm-dd') as siWangShiJian,wj.anJuanHao,wj.xingBie,wj.chuShengNianYue,wj.liJuanDanWeiMingCheng,aj.xuHao from ")).append(table).append(" wj, D_ZhuanYeAnJuan aj where 1=1 and wj.guanLianBiaoShi = aj.hangBiaoShi and wj.zhuangTai not in(:zhuangTai)");
    } else if (StringUtils.isNotBlank((String)map.get("menLei")) && "TDCGWS".equals(map.get("menLei"))) {
      sql = (new StringBuffer(" select wj.yeShu,wj.hangBiaoShi,wj.biaoTi,wj.quanZongHao,wj.guiDangNianDu,wj.muLuHao,wj.cunFangWeiZhi,wj.dangHao,wj.fenLeiMingCheng,wj.fenLeiHao,wj.zeRenZhe,wj.siWangShiJian,wj.anJuanHao,wj.xingBie,wj.chuShengNianYue,wj.liJuanDanWeiMingCheng,wj.beiZhu,wj.xuHao from ")).append(table).append(" wj where 1=1 and wj.zhuangTai not in(:zhuangTai)");
    } else {
      sql = (new StringBuffer(" select wj.yeShu,wj.hangBiaoShi,wj.biaoTi,wj.quanZongHao,wj.guiDangNianDu,wj.muLuHao,wj.cunFangWeiZhi,wj.dangHao,wj.fenLeiMingCheng,wj.fenLeiHao,wj.zeRenZhe,wj.siWangShiJian,wj.anJuanHao,wj.xingBie,wj.chuShengNianYue,wj.liJuanDanWeiMingCheng,wj.beiZhu from ")).append(table).append(" wj where 1=1 and wj.zhuangTai not in(:zhuangTai)");
    } 
    pinjieSql(sql, tp, map);
    return this.zhuanYeWenJianDao.getListMap(sql.toString(), tp);
  }
  
  private void pinjieSql(StringBuffer sql, Map<String, Object> tp, Map<String, Object> map) {
    Object importExcelTool = map.get("importTool");
    if (StringUtils.isNotBlank((String)importExcelTool)) {
      if (importExcelTool.equals("importTool"))
        tp.put("zhuangTai", new String[] { "6", "6" }); 
    } else {
      tp.put("zhuangTai", new String[] { "3", "4", "6" });
    } 
    Object para = null;
    para = map.get("querystr");
    if (para != null && para != "") {
      Object menLei = map.get("menLei");
      if (menLei != null && menLei != "") {
        sql.append(" and wj.menLei =:menLei");
        tp.put("menLei", menLei);
      } 
      CommStatic.zhuHeQueryJieXi_map(sql, tp, para.toString(), (String)map.get("zuHeType"), getDataType());
    } else {
      para = map.get("hbs");
      if (para != null && para != "") {
        sql.append(" and wj.hangbiaoshi in(:hangbiaoshi)");
        tp.put("hangbiaoshi", para.toString().split(","));
      } else {
        para = map.get("biaoTi");
        if (para != null && para != "") {
          sql.append(" and wj.biaoTi like :biaoTi");
          tp.put("biaoTi", "%" + para + "%");
        } 
        para = map.get("quanZongHao");
        if (para != null && para != "") {
          sql.append(" and wj.quanZongHao=:quanZongHao");
          tp.put("quanZongHao", para);
        } 
        para = map.get("guiDangNianDu");
        if (para != null && para != "") {
          tp.put("guiDangNianDu", para);
          para = map.get("guiDangNianDu_Operator");
          if (para != null && para != "") {
            sql.append(" and wj.guiDangNianDu ").append(para).append(":guiDangNianDu");
          } else {
            sql.append(" and wj.guiDangNianDu ").append("=:guiDangNianDu");
          } 
        } 
        para = map.get("muLuHao");
        if (para != null && para != "") {
          sql.append(" and wj.muLuHao=:muLuHao");
          tp.put("muLuHao", para);
        } 
        para = map.get("cunFangWeiZhi");
        if (para != null && para != "") {
          sql.append(" and wj.cunFangWeiZhi=:cunFangWeiZhi");
          tp.put("cunFangWeiZhi", para);
        } 
        para = map.get("dangHao");
        if (para != null && para != "") {
          sql.append(" and wj.dangHao=:dangHao");
          tp.put("dangHao", para);
        } 
        para = map.get("youYuanWen");
        if (para != null && para != "") {
          if ("1".equals(para)) {
            sql.append(" and wj.youYuanWen=:youYuanWen");
          } else {
            sql.append(" and (wj.youYuanWen=:youYuanWen");
            sql.append(" or wj.youYuanWen is null)");
          } 
          tp.put("youYuanWen", para);
        } 
      } 
      para = map.get("menLei");
      if (para != null && para != "") {
        sql.append(" and wj.menLei=:menLei");
        tp.put("menLei", para);
      } 
      para = map.get("fuJianBiaoTi");
      if (para != null && para != "") {
        sql.append(" and wj.hangbiaoshi in(select DISTINCT  guanlianbiaoshi from D_ZHUANYEWENJIANFUJIAN t where (t.yuanwenjianming  like:yuanwenjianming or t.biaoti like:fbiaoti))");
        tp.put("yuanwenjianming", "%" + para + "%");
        tp.put("fbiaoti", "%" + para + "%");
      } 
    } 
  }
}
